//+------------------------------------------------------------------+
//|                                           Price Channel Diff.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
 
#property link      "Bill Burns"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Blue
//---- input parameters
extern int ChannelPeriod = 14;
extern int ShiftValue = 1;
//---- buffers
double DiffBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- indicator line
   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0, DiffBuffer);
//---- name for DataWindow and indicator subwindow label
   short_name="Channel Difference("+ChannelPeriod+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0, "Difference");
//----
   SetIndexDrawBegin(0, ChannelPeriod);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Price Channel                                                         |
//+------------------------------------------------------------------+
int start()
  {
   int i, counted_bars = IndicatorCounted();
   int    k;
   double high, low, price;
//----
   if(Bars <= ChannelPeriod) 
       return(0);
//---- initial zero
   if(counted_bars < 1)
      for(i = 1;i <= ChannelPeriod; i++) 
          DiffBuffer[Bars-i] = 0.0;
//----
   i = Bars - ChannelPeriod - 1;
   if(counted_bars >= ChannelPeriod) 
       i = Bars - counted_bars - 1;
   while(i-ShiftValue >= 0)
     {
       high = High[i]; 
       low = Low[i]; 
       k = i - 1 + ChannelPeriod;
       while(k >= i)
         {
           price = High[k];
           if(high < price) 
               high = price;
           price = Low[k];
           if(low > price)  
               low = price;
           k--;
         } 
       DiffBuffer[i-ShiftValue] = NormalizeDouble(high,Digits) - NormalizeDouble(low,Digits);
       i--;
     }
   return(0);
  }
//+------------------------------------------------------------------+